-------------------------------------------------------------------------------
-- Dumb Knight
--Copyright (C) 2013  Thoughts of Glought

--This program is free software: you can redistribute it and/or modify
--it under the terms of the GNU General Public License as published by
--the Free Software Foundation, either version 3 of the License, or
--(at your option) any later version.
--------------------------------------------------------------------------------
--This program is distributed in the hope that it will be useful,
--but WITHOUT ANY WARRANTY; without even the implied warranty of
--MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--GNU General Public License for more details.
---------------------------------------------------------------------------------
--You should have received a copy of the GNU General Public License
--along with this program.  If not, see <http://www.gnu.org/licenses/>.
----------------------------------------------------------------------------------
local DBK = LibStub("AceAddon-3.0"):GetAddon("Dumbknight")
local DBK_Warlock = DBK:NewModule("WarlockDBK","AceEvent-3.0","AceTimer-3.0","AceConsole-3.0")
local PetTimer
local timerCount = 0

local scanTool = CreateFrame( "GameTooltip", "ScanTooltip", nil, "GameTooltipTemplate" )
scanTool:SetOwner( WorldFrame, "ANCHOR_NONE" )
local scanText = _G["ScanTooltipTextLeft2"]

--local IsInGroup = true
function DBK_Warlock:Enable()
	DBK_Warlock:RegisterEvent("PLAYER_ENTERING_WORLD", "setdbkpettimer")
	DBK_Warlock:RegisterEvent("LFG_COMPLETION_REWARD","cancelPetTimer")

end

function DBK_Warlock:getPetOwner(petName)
	if IsInGroup() then
		scanTool:ClearLines()
		scanTool:SetUnit(petName)
		local ownerText = scanText:GetText()
		if not ownerText then return nil end
		local owner, _ = string.split("'",ownerText)

		return owner
	end
end

function DBK_Warlock:petCheck(...)
	local ttype, _, sourceGUID, sourceName, sourceFlags, _, destGUID, destName, destFlags, _, spellId, spellName = select(3, ...);
    
    if
	(ttype == "SPELL_CAST_SUCCESS")
	and
	(bit.band(COMBATLOG_OBJECT_TYPE_MASK, sourceFlags) == COMBATLOG_OBJECT_TYPE_PET)
	and
	(bit.band(COMBATLOG_OBJECT_AFFILIATION_MASK, sourceFlags)
	<= COMBATLOG_OBJECT_AFFILIATION_RAID)
	and
	spellId == 17735
	then
		local getpetowner = DBK_Warlock:getPetOwner(sourceName)
		local petownernamesplit

		if getpetowner ~= nil and string.find(getpetowner, "-") then
			petownernamesplit = string.split("-",getpetowner)
		else
			petownernamesplit = getpetowner
		end

		if timerCount >= 4 then
			if DBK.db.global.instancechatpets then
				SendChatMessage("Hey " .. petownernamesplit .. " turn off " .. spellName .. " and any other threat generating abilities now! Everyone will keep getting this message until you turn them off.","INSTANCE_CHAT",nil,nil)
			else
				SendChatMessage("Hey " .. petownernamesplit .. " turn off " .. spellName .. " and any other threat generating abilities now! You will keep getting this whisper until you turn them off.","WHISPER",nil,getpetowner)
			end
		end
		if DBK.db.global.debug then
			print(spellName)
			print(sourceName)
			print(getpetowner)
		end
	end
end

function DBK_Warlock:cancelPetTimer()
	DBK_Warlock:CancelTimer(PetTimer)
	timerCount = 2
	if DBK.db.global.debug then
		DBK:Print("dev","Timer Canceled")
	end
end

function DBK_Warlock:setdbkpettimer()

	DBK_Warlock:ScheduleTimer("dbkpettimerset",23)

end

function DBK_Warlock:dbkpettimerset()
	local Player_Role = UnitGroupRolesAssigned("player")
	if DBK.db.global.hunterwarlockraidwarn and IsInRaid() then
		if IsInGroup() and Player_Role == "TANK" then
			PetTimer = DBK_Warlock:ScheduleRepeatingTimer("dbkpettimer" , 10)
			timerCount = 2
		else
			DBK:Print("Not in group(Warlock)")
		end

	else
		if IsInGroup() and IsInRaid() == false then
			PetTimer = DBK_Warlock:ScheduleRepeatingTimer("dbkpettimer" , 10)
			timerCount = 2
		else
			DBK:Print("Not in group(Warlock)")
		end
	end

end

function DBK_Warlock:dbkpettimer()
	timerCount = timerCount + 2
	if timerCount > 5 then
		timerCount = 2
	end
	if DBK.db.global.debug then
	-- print(timerCount .. " " .. GetTime())
	end
end
